routes/web.php
<?php

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('welcome');
});

Auth::routes();

Route::get('/home', [App\Http\Controllers\HomeController::class, 'index'])->name('home');

Auth::routes();

Route::get('/home', [App\Http\Controllers\HomeController::class, 'index'])->name('home');


Route::resource('projects', App\Http\Controllers\ProjectController::class);

Route::resource('tags', App\Http\Controllers\TagController::class);

app/Models/Project.php
<?php

namespace App\Models;

use Eloquent as Model;
use Illuminate\Database\Eloquent\SoftDeletes;
use Illuminate\Database\Eloquent\Factories\HasFactory;

/**
 * Class Project
 * @package App\Models
 * @version March 13, 2021, 6:20 pm UTC
 *
 * @property string $title
 * @property string $description
 * @property integer $status
 */
class Project extends Model
{
    use SoftDeletes;

    use HasFactory;

    public $table = 'projects';


    protected $dates = ['deleted_at'];



    public $fillable = [
        'title',
        'description',
//        'status'
    ];

    /**
     * The attributes that should be casted to native types.
     *
     * @var array
     */
    protected $casts = [
        'id' => 'integer',
        'title' => 'string',
        'description' => 'string',
        'status' => 'integer'
    ];

    /**
     * Validation rules
     *
     * @var array
     */
    public static $rules = [
        'title' => 'required',
        'description' => 'required',
        'status' => 'exit'
    ];
    const status = [
      1 => 'Pending',
      2 => 'Finished',
    ];
    protected $append=['status_name'];
    public function getStatusNameAttribute()
    {
        return self::status;
    }

}

app/Http/Controllers/ProjectController.php
<?php

namespace App\Http\Controllers;

use App\Http\Requests\CreateProjectRequest;
use App\Http\Requests\UpdateProjectRequest;
use App\Queries\ProjectDataTable;
use App\Repositories\ProjectRepository;
use App\Http\Controllers\AppBaseController;
use Illuminate\Http\Request;
use Flash;
use Response;
use Yajra\DataTables\DataTables;

class ProjectController extends AppBaseController
{
    /** @var  ProjectRepository */
    private $projectRepository;

    public function __construct(ProjectRepository $projectRepo)
    {
        $this->projectRepository = $projectRepo;
    }

    /**
     * Display a listing of the Project.
     *
     * @param Request $request
     *
     * @return Response
     * @throws \Exception
     */
    public function index(Request $request)
    {
        $projects = $this->projectRepository->all();
        if ($request->ajax())
        {
            return DataTables::of((new ProjectDataTable())->get())->make(true);
        }

        return view('projects.index')
            ->with('projects', $projects);
    }

    /**
     * Show the form for creating a new Project.
     *
     * @return Response
     */
    public function create()
    {
        return view('projects.create');
    }

    /**
     * Store a newly created Project in storage.
     *
     * @param CreateProjectRequest $request
     *
     * @return Response
     */
    public function store(CreateProjectRequest $request)
    {
        $input = $request->all();

        $project = $this->projectRepository->create($input);

        Flash::success('Project saved successfully.');
        return $this->sendSuccess('Inserted SuccessFully !!');
//        return redirect(route('projects.index'));
    }

    /**
     * Display the specified Project.
     *
     * @param int $id
     *
     * @return Response
     */
    public function show($id)
    {
        $project = $this->projectRepository->find($id);

        if (empty($project)) {
            Flash::error('Project not found');

            return redirect(route('projects.index'));
        }

        return view('projects.show')->with('project', $project);
    }

    /**
     * Show the form for editing the specified Project.
     *
     * @param int $id
     *
     * @return Response
     */
    public function edit($id)
    {
        $project = $this->projectRepository->find($id);

        if (empty($project)) {
            Flash::error('Project not found');

            return redirect(route('projects.index'));
        }

        return $this->sendResponse($project,'Retrieved SuccessFully');
//        return view('projects.edit')->with('project', $project);
    }

    /**
     * Update the specified Project in storage.
     *
     * @param int $id
     * @param UpdateProjectRequest $request
     *
     * @return Response
     */
    public function update($id, UpdateProjectRequest $request)
    {
        $project = $this->projectRepository->find($id);

        if (empty($project)) {
            Flash::error('Project not found');

            return redirect(route('projects.index'));
        }

        $project = $this->projectRepository->update($request->all(), $id);

        Flash::success('Project updated successfully.');
        return $this->sendSuccess('Update SuccessFully');
//        return redirect(route('projects.index'));
    }

    /**
     * Remove the specified Project from storage.
     *
     * @param int $id
     *
     * @throws \Exception
     *
     * @return Response
     */
    public function destroy($id)
    {
        $project = $this->projectRepository->find($id);

        if (empty($project)) {
            Flash::error('Project not found');

            return redirect(route('projects.index'));
        }

        $this->projectRepository->delete($id);

        Flash::success('Project deleted successfully.');
        return $this->sendSuccess('Record Deleted SuccessFully');

//        return redirect(route('projects.index'));
    }
}

resources/views/projects/create.blade.php
<div class="modal fade" id="exampleModal" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel" aria-hidden="true">
    <div class="modal-dialog" role="document">
        <div class="modal-content">
            <div class="modal-header">
                <h5 class="modal-title" id="exampleModalLabel">Modal title</h5>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>
            <div class="modal-body">
                {!! Form::open(['id'=>'FormCreate']) !!}
                    <div class="form-group col-sm-6">
                        {!! Form::label('title', 'Title:') !!}
                        {!! Form::text('title', null, ['class' => 'form-control']) !!}
                    </div>
                    <div class="form-group col-sm-12 col-lg-12">
                        {!! Form::label('description', 'Description:') !!}
                        {!! Form::textarea('description', null, ['class' => 'form-control','id'=>'summernote']) !!}
                    </div>
                    <div class="form-group col-sm-12">
                        {!! Form::submit('Save', ['class' => 'btn btn-primary']) !!}
                        <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
                    </div>
                {!! Form::close() !!}
            </div>
            <div class="modal-footer">
            </div>
        </div>
    </div>
</div>

resources/views/projects/edit.blade.php
<div class="modal fade" id="EditModal" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel" aria-hidden="true">
    <div class="modal-dialog" role="document">
        <div class="modal-content">
            <div class="modal-header">
                <h5 class="modal-title" id="exampleModalLabel">Modal title</h5>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>
            <div class="modal-body">
                {!! Form::open(['id'=>'FormEdit']) !!}
                @csrf
                @method('PUT')
                {!! Form::hidden('project_id',null,['id'=>'projectId']) !!}
                <div class="form-group col-sm-6">
                    {!! Form::label('title', 'Title:') !!}
                    {!! Form::text('title', null, ['class' => 'form-control title','id'=>'title']) !!}
                </div>
                <div class="form-group col-sm-12 col-lg-12">
                    {!! Form::label('description', 'Description:') !!}
                    {!! Form::textarea('description', null, ['class' => 'form-control description','id'=>'summernote']) !!}
                </div>
                <div class="form-group col-sm-12">
                    {!! Form::submit('Save', ['class' => 'btn btn-primary']) !!}
                    <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
                </div>
                {!! Form::close() !!}
            </div>
            <div class="modal-footer">
            </div>
        </div>
    </div>
</div>

resources/views/projects/fields.blade.php
<!-- Title Field -->
<div class="form-group col-sm-6">
    {!! Form::label('title', 'Title:') !!}
    {!! Form::text('title', null, ['class' => 'form-control']) !!}
</div>

<!-- Description Field -->
<div class="form-group col-sm-12 col-lg-12">
    {!! Form::label('description', 'Description:') !!}
    {!! Form::textarea('description', null, ['class' => 'form-control']) !!}
</div>

<!-- Submit Field -->
<div class="form-group col-sm-12">
    {!! Form::submit('Save', ['class' => 'btn btn-primary']) !!}
    <a href="{{ route('projects.index') }}" class="btn btn-secondary">Cancel</a>
</div>

resources/views/projects/index.blade.php
@extends('layouts.app')

@section('content')
    <ol class="breadcrumb">
        <li class="breadcrumb-item">Projects</li>
    </ol>
    <div class="container-fluid">
        <div class="animated fadeIn">
            @include('flash::message')
            <div class="row">
                <div class="col-lg-12">
                    <div class="card">
                        <div class="card-header">
                            <i class="fa fa-align-justify"></i>
                            Projects
                            <a class="pull-right" data-toggle="modal" data-target="#exampleModal"><i
                                    class="fa fa-plus-square fa-lg"></i></a>
                        </div>
                        <div class="card-body">
                            @include('projects.table')
                            <div class="pull-right mr-3">

                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        @include('projects.create')
        @include('projects.templates.template')
        @include('projects.edit')
    </div>
@endsection
@push('scripts')
    <script>
        $(document).ready(function () {
            $.ajaxSetup({
                headers: {
                    'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content')
                }
            });
            let IndexUrl = "{{route('projects.index')}}";
            $('#summernote').summernote();
            $('#projects-table').DataTable({
                ajax: "{{route('projects.index')}}",
                processing: true,
                serverSide: true,
                columnDefs : [
                    {
                        'targets': [0],
                        // 'width':'',
                    },
                    {
                        'targets':[3],
                        'width':'5 %',
                        'orderable': false,
                        'className':'text-center',
                    }
                ],
                columns: [

                    {
                        data: 'title',
                        name: 'title',
                    },
                    {
                        data: 'description',
                        name: 'description',
                    },
                        {{--{--}}
                        {{--    data: function (row){--}}
                        {{--       let data =  row.description;--}}
                        {{--       let Record =  $('#summernote').summernote('code',data);--}}
                        {{--       return {!!  'Record' !!};--}}
                        {{--    },name:'description',--}}
                        {{--},--}}
                    {
                        data: 'status',
                        name: 'status',
                    },
                    {
                        data: function (row) {
                            let template = $.templates('#projectTemplate');
                            let data = [{'id': row.id}];
                            return template.render(data);
                        }, name: 'id',
                    },
                ]
            });
            $(document).on('submit', '#FormCreate', function (e) {
                e.preventDefault();
                $.ajax({
                    url: "{{route('projects.store')}}",
                    type: 'POST',
                    data: $(this).serialize(),
                    success: function (result) {
                        if (result.success) {
                            $('#exampleModal').modal('hide');
                            $('#projects-table').DataTable().ajax.reload(null, false);
                            $('#FormCreate')[0].reset();
                            $.toast({
                                heading: 'Details',
                                text: 'Record Added SuccessFully',
                                position: 'top-right',
                                stack: false
                            })
                        }
                    },
                    error: function (e) {
                        $.toast({
                            heading: 'Error',
                            text: 'Please Input All Filed' + e,
                            showHideTransition: 'fade',
                            position: 'top-right',
                            icon: 'error'
                        })
                    }
                });
            });

            // edit code
            $(document).on('click', '.editBtn', function (e) {
                e.preventDefault();
                let id = $(this).attr('data-id');
                $('#projectId').val(id);
                $.ajax({
                    url: IndexUrl + '/' + id + '/' + 'edit',
                    type: 'GET',
                    success: function (result) {
                        if (result.success) {
                            $('.title').val(result.data.title);
                            $('.description').summernote('code', result.data.description);
                        }
                    }
                });
            });
            $(document).on('submit', '#FormEdit', function (e) {
                e.preventDefault();
                let id = $('#projectId').val();
                $.ajax({
                    url: IndexUrl + '/' + id,
                    type: 'PUT',
                    data: $(this).serialize(),
                    success: function (result) {
                        if (result.success) {
                            $('#EditModal').modal('hide');
                            $('#projects-table').DataTable().ajax.reload(null, false);
                            $('#FormEdit')[0].reset();
                            $.toast({
                                heading: 'Success',
                                text: 'Update SuccessFully Record',
                                showHideTransition: 'slide',
                                position: 'top-right',
                                icon: 'success'
                            })
                        }
                    },
                    error: function (e) {
                        console.log(e);
                        $.toast({
                            heading: 'Error',
                            text: 'Please Input All Filed' + e,
                            showHideTransition: 'fade',
                            position: 'top-right',
                            icon: 'error'
                        })
                    }
                });
            });

            // delete code
            $(document).on('click', '.deleteBtn', function (e) {
                let id = $(this).attr('data-id');
                swal({
                    title: "Are you sure?",
                    text: "Once deleted, you will not be able to recover this  file!",
                    icon: "warning",
                    buttons: true,
                    dangerMode: true,
                })
                    .then((willDelete) => {
                        if (willDelete) {
                            swal(" Your  file has been deleted!", {
                                icon: "success",
                            });
                            $.ajax({
                                url: IndexUrl + '/' + id,
                                type: 'DELETE',
                                success: function (result)
                                {
                                    if (result.success)
                                    {
                                        $('#projects-table').DataTable().ajax.reload(null,false);0
                                    }
                                }
                            });
                        } else {
                            swal("Your  file is safe!");
                        }
                    });

            });
        });
    </script>
@endpush

resources/views/projects/show.blade.php
@extends('layouts.app')

@section('content')
     <ol class="breadcrumb">
            <li class="breadcrumb-item">
                <a href="{{ route('projects.index') }}">Project</a>
            </li>
            <li class="breadcrumb-item active">Detail</li>
     </ol>
     <div class="container-fluid">
          <div class="animated fadeIn">
                 @include('coreui-templates::common.errors')
                 <div class="row">
                     <div class="col-lg-12">
                         <div class="card">
                             <div class="card-header">
                                 <strong>Details</strong>
                                  <a href="{{ route('projects.index') }}" class="btn btn-light">Back</a>
                             </div>
                             <div class="card-body">
                                 @include('projects.show_fields')
                             </div>
                         </div>
                     </div>
                 </div>
          </div>
    </div>
@endsection

resources/views/projects/show_fields.blade.php
<!-- Title Field -->
<div class="form-group">
    {!! Form::label('title', 'Title:') !!}
    <p>{{ $project->title }}</p>
</div>

<!-- Description Field -->
<div class="form-group">
    {!! Form::label('description', 'Description:') !!}
    <p>{{ $project->description }}</p>
</div>

<!-- Status Field -->
<div class="form-group">
    {!! Form::label('status', 'Status:') !!}
    <p>{{ $project->status }}</p>
</div>

<!-- Created At Field -->
<div class="form-group">
    {!! Form::label('created_at', 'Created At:') !!}
    <p>{{ $project->created_at }}</p>
</div>

<!-- Updated At Field -->
<div class="form-group">
    {!! Form::label('updated_at', 'Updated At:') !!}
    <p>{{ $project->updated_at }}</p>
</div>

resources/views/projects/table.blade.php
<div class="table-responsive-sm">
    <table class="table table-striped" id="projects-table">
        <div class="row">
                <thead class="col col-md-6 col-sm-3">
                <tr>
                    <th>Title</th>
                    <th>Description</th>
                    <th>Status</th>
                    <th>Action</th>
                </tr>
                </thead>
                <tbody class="col col-md-6 col-sm-3">
                </tbody>
            </div>
    </table>
</div>